<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script>
        'use strict'
        $(document).ready(function(){
            // REGION 1:
            const gREQUEST_STATUS_OK = 200;
            const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
            // REGION 2:
            // Gán sự kiện on click cho nút ném:
            $("#btn-dice").click(onBtnGetDiceClick)
            // REGION 3:
            // Hàm xử lý sự kiện nút Ném được click:
            function onBtnGetDiceClick(){
                console.log("btn pressed")
                var vDataObject = {
                firstname: "",
                lastname: "",
                username: ""
                };
                // B1: Get Data
                getDataFromInput(vDataObject);
                // B2: Validate Data
                var vDataValid = validateData(vDataObject);
                // B3: Display Data
                if (vDataValid){
                    // Chuyển object về chuỗi json:
                    var vPersonJsonString = JSON.stringify(vDataObject);
                    // Create request:
                    var vXmlHttpRequest = new XMLHttpRequest();
                    // Send request:
                    sendRequestNewDice(vXmlHttpRequest, vPersonJsonString);

                    vXmlHttpRequest.onreadystatechange = function () {
                        // Khi request đã xử lý xong và thành công!
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {                           
                            var vResponseObj = JSON.parse(vXmlHttpRequest.responseText);
                            console.log(vResponseObj)
                            displayDice(vResponseObj);
                            // Hiển thị voucher nếu có
                            if (vResponseObj.voucher != null){
                                displayVoucher(vResponseObj);
                            }
                            // Hiển thị phần thưởng nếu có
                            if (vResponseObj.prize != null){
                                displayPrize(vResponseObj);
                            }
                        }
                    }
                }
            }
            // REGION 4:
            // Hàm thu thập dữ liệu:
            function getDataFromInput(paramDataObj){
                paramDataObj.firstname = $("#inp-first-name").val().trim();
                paramDataObj.lastname = $("#inp-last-name").val().trim();
                paramDataObj.username = $("#inp-user-name").val().trim();
            };

            // Hàm kiểm tra dữ liệu:
            function validateData(paramDataObj){
                var vResult = true;
                if (paramDataObj.username == ""){
                    vResult = false;
                    alert("Hãy nhập username")
                }
                else if (paramDataObj.firstname == ""){
                    vResult = false;
                    alert("Hãy nhập firstname!")
                }
                else if (paramDataObj.lastname == ""){
                    vResult = false;
                    alert("Hãy nhập lastname!")
                }
                return vResult;
            };

            // Hàm xử lý hiển thị dữ liệu:
            function displayData(paramDataObj){
                console.log("Username: " + paramDataObj.username);
                console.log("Firstname: " + paramDataObj.firstname);
                console.log("Lastname: " + paramDataObj.lastname);
            }
        
            // Hàm gửi dữ liệu lên server lấy Dice mới:
            function sendRequestNewDice(paramXmlHttpRequest, paramJsonString){
                'use strict'
                const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
                const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

                paramXmlHttpRequest.open("POST", vBASE_URL + "/dice", true);
                paramXmlHttpRequest.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
                paramXmlHttpRequest.send(paramJsonString);
            };

            // Hàm xử lý hiện thị xí ngầu mới:
            function displayDice(paramResponseObj){
                var vDiceResult = paramResponseObj.dice;
                var vNewDiceImgUrl = "LuckyDiceImages/" + vDiceResult.toString() + ".png";
                $("#img-dice").prop("src",vNewDiceImgUrl);

                // Hiển thị chúc mừng nếu kết quả lớn hơn 3, chia buồn nếu kết quả là còn lại:
                if (vDiceResult > 3){
                    $("#p-notification-dice").html("Chúc mừng!");
                } else {
                    $("#p-notification-dice").html("Chúc may mắn lần sau!");
                }
            };

            // Hàm xử lý hiện thị voucher:
            function displayVoucher(paramResponseObj){
                $("#p-voucher-id").html("Mã Voucher: " + paramResponseObj.voucher.maVoucher);
                $("#p-voucher-percent").html("Giảm giá " + paramResponseObj.voucher.phanTramGiamGia + "%");
            };

            // Hàm xử lý hiện thị phần thưởng:
            function displayPrize(paramResponseObj){
                var vPrize = paramResponseObj.prize;
                if (vPrize == "Ô tô"){
                    $("#img-present").prop("src", "LuckyDiceImages/car.jpg");
                }
                else if (vPrize == "Xe máy"){
                    $("#img-present").prop("src", "LuckyDiceImages/xe-may.jpg");
                }
                else if (vPrize == "Áo"){
                    $("#img-present").prop("src", "LuckyDiceImages/t-shirt.jpg");
                }
                else if (vPrize == "Mũ"){
                    $("#img-present").prop("src", "LuckyDiceImages/hat.jpg");
                }
            }
        })
    </script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhánh Develop Gitlab Lucky Dice</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/no-present.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>

</script>

</html>